module FNV exposing (hashString)

{-| FNV hash function for hashing strings

@docs hashString

-}

import Bitwise
import String
import Char


fnvPrime : Int
fnvPrime =
    (2 ^ 24) + (2 ^ 8) + 0x93


{-| Takes a string. Produces a hash (integer).

    hashString "Turn me into a hash" == 4138100590
-}
hashString : String -> Int
hashString str =
    String.foldl hashFold 0 str


hashFold : Char -> Int -> Int
hashFold c hash =
    ((hash `Bitwise.xor` (Char.toCode c)) * fnvPrime) `Bitwise.shiftRightLogical` 0
